#!/usr/bin/env python
##################################################
# Gnuradio Python Flow Graph
# Title: Mpsk Stage1
# Generated: Sun Sep 23 16:18:24 2012
##################################################

from PyQt4 import Qt
from gnuradio import digital
from gnuradio import eng_notation
from gnuradio import gr
from gnuradio.eng_option import eng_option
from gnuradio.gr import firdes
from gnuradio.qtgui import qtgui
from optparse import OptionParser
import math
import numpy
import sip
import sys

class mpsk_stage1(gr.top_block, Qt.QWidget):

	def __init__(self):
		gr.top_block.__init__(self, "Mpsk Stage1")
		Qt.QWidget.__init__(self)
		self.setWindowTitle("Mpsk Stage1")
		self.setWindowIcon(Qt.QIcon.fromTheme('gnuradio-grc'))
		self.top_scroll_layout = Qt.QVBoxLayout()
		self.setLayout(self.top_scroll_layout)
		self.top_scroll = Qt.QScrollArea()
		self.top_scroll.setFrameStyle(Qt.QFrame.NoFrame)
		self.top_scroll_layout.addWidget(self.top_scroll)
		self.top_scroll.setWidgetResizable(True)
		self.top_widget = Qt.QWidget()
		self.top_scroll.setWidget(self.top_widget)
		self.top_layout = Qt.QVBoxLayout(self.top_widget)
		self.top_grid_layout = Qt.QGridLayout()
		self.top_layout.addLayout(self.top_grid_layout)


		##################################################
		# Variables
		##################################################
		self.sps = sps = 4
		self.samp_rate = samp_rate = 32000
		self.arity = arity = 4

		##################################################
		# Blocks
		##################################################
		self.random_source_x_0 = gr.vector_source_b(map(int, numpy.random.randint(0, 256, 1000000)), True)
		self.qtgui_sink_x_0_1 = qtgui.sink_c(
			1024, #fftsize
			firdes.WIN_BLACKMAN_hARRIS, #wintype
			0, #fc
			samp_rate, #bw
			"QT GUI Plot", #name
			True, #plotfreq
			False, #plotwaterfall
			False, #plottime
			False, #plotconst
		)
		self._qtgui_sink_x_0_1_win = sip.wrapinstance(self.qtgui_sink_x_0_1.pyqwidget(), Qt.QWidget)
		self.top_layout.addWidget(self._qtgui_sink_x_0_1_win)
		self.qtgui_sink_x_0_0 = qtgui.sink_c(
			1024, #fftsize
			firdes.WIN_BLACKMAN_hARRIS, #wintype
			0, #fc
			samp_rate, #bw
			"QT GUI Plot", #name
			False, #plotfreq
			False, #plotwaterfall
			False, #plottime
			True, #plotconst
		)
		self._qtgui_sink_x_0_0_win = sip.wrapinstance(self.qtgui_sink_x_0_0.pyqwidget(), Qt.QWidget)
		self.top_grid_layout.addWidget(self._qtgui_sink_x_0_0_win, 0,1,1,1)
		self.qtgui_sink_x_0 = qtgui.sink_c(
			1024, #fftsize
			firdes.WIN_BLACKMAN_hARRIS, #wintype
			0, #fc
			samp_rate, #bw
			"QT GUI Plot", #name
			False, #plotfreq
			False, #plotwaterfall
			True, #plottime
			False, #plotconst
		)
		self._qtgui_sink_x_0_win = sip.wrapinstance(self.qtgui_sink_x_0.pyqwidget(), Qt.QWidget)
		self.top_grid_layout.addWidget(self._qtgui_sink_x_0_win, 0,0,1,1)
		self.gr_throttle_0 = gr.throttle(gr.sizeof_gr_complex*1, samp_rate)
		self.gr_multiply_const_vxx_0 = gr.multiply_const_vcc((complex(1,1), ))
		self.digital_psk_mod_0 = digital.psk.psk_mod(
		  constellation_points=arity,
		  mod_code="gray",
		  differential=True,
		  samples_per_symbol=sps,
		  excess_bw=0.35,
		  verbose=False,
		  log=False,
		  )

		##################################################
		# Connections
		##################################################
		self.connect((self.gr_multiply_const_vxx_0, 0), (self.gr_throttle_0, 0))
		self.connect((self.digital_psk_mod_0, 0), (self.gr_multiply_const_vxx_0, 0))
		self.connect((self.random_source_x_0, 0), (self.digital_psk_mod_0, 0))
		self.connect((self.gr_throttle_0, 0), (self.qtgui_sink_x_0, 0))
		self.connect((self.gr_throttle_0, 0), (self.qtgui_sink_x_0_0, 0))
		self.connect((self.gr_throttle_0, 0), (self.qtgui_sink_x_0_1, 0))

	def get_sps(self):
		return self.sps

	def set_sps(self, sps):
		self.sps = sps

	def get_samp_rate(self):
		return self.samp_rate

	def set_samp_rate(self, samp_rate):
		self.samp_rate = samp_rate
		self.qtgui_sink_x_0_1.set_frequency_range(0, self.samp_rate)
		self.qtgui_sink_x_0_0.set_frequency_range(0, self.samp_rate)
		self.qtgui_sink_x_0.set_frequency_range(0, self.samp_rate)

	def get_arity(self):
		return self.arity

	def set_arity(self, arity):
		self.arity = arity

if __name__ == '__main__':
	parser = OptionParser(option_class=eng_option, usage="%prog: [options]")
	(options, args) = parser.parse_args()
	qapp = Qt.QApplication(sys.argv)
	tb = mpsk_stage1()
	tb.start()
	tb.show()
	qapp.exec_()
	tb.stop()

